#!/bin/bash

## JAVA4
CURRENTDIR=`pwd`
SCRIPTDIR=`dirname $CURRENTDIR/$0`
export CLASSPATH=$SCRIPTDIR:$CLASSPATH

###################################
KEYSTORE=$SCRIPTDIR/../../certificates/User-CA/User/Mallory.keystore
KEYSTOREPASSWORD=Mallory
TRUSTSTORE=$SCRIPTDIR/../../certificates/User-CA/User/Mallory.keystore
TRUSTSTOREPASSWORD=Mallory
###################################



#keytool -list -v -keystore $KEYSTORE -storepass $KEYSTOREPASSWORD

# -Djavax.net.debug=all
java -classpath $CLASSPATH -Dindigo.keyStore=$KEYSTORE -Dindigo.keyStorePassword=$KEYSTOREPASSWORD -Dindigo.keyStoreType=JKS -Dindigo.keyManagerFactoryAlgorithm=SunX509 -Dindigo.trustStore=$TRUSTSTORE -Dindigo.trustStorePassword=$TRUSTSTOREPASSWORD -Dindigo.trustStoreType=JKS -Dindigo.trustManagerFactoryAlgorithm=SunX509 -Dindigo.httpsProtocols=SSL SSLClient $*

