# -*- python -*-
#
#  quit.py
#
#  Copyright (C) 1999  Christian Moench
#
#  $Id: quit.py,v 2.6 1999/12/19 16:14:44 razi Exp $
#  $Date: 1999/12/19 16:14:44 $
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
#  Christian Moench
#  Dept. of Computer Science
#  Johann Wolfgang Goethe-University
#  60325 Frankfurt, Germany
#  Tel.  +49 69 79828358
#  Fax.  +49 69 79823340
#
#  $Log: quit.py,v $
#  Revision 2.6  1999/12/19 16:14:44  razi
#  Including IndigoConfig.java
#
#  Revision 2.2  1999/12/15 16:34:17  cristian
#  added new clients
#
#  Revision 2.0  1999/12/15 15:38:51  cristian
#  added new clients
#
#  Revision 1.1  1999/12/15 10:19:24  cristian
#  new clients for `documents' and `quit'
#
#


def main():
	import string, sys, httplib
	
	if len(sys.argv) <> 3:
		sys.stderr.write("usage: quit server portnumber\n")
		sys.exit(1)

	# Convert port number to integer
	try:
		port = int(sys.argv[2])
	except:
		sys.stderr.write("illegal port number\n")
		sys.exit(2)

	# Send request
	httpStub = httplib.HTTP(sys.argv[1], port)
	httpStub.putrequest("GET", "/diglib/quit")
	httpStub.endheaders()

	# Check reply code
	reply = httpStub.getreply()
        if reply[0] <> 200:
            sys.stderr.write('%d %s\n\n' % reply[0:2])
            # Show errors
            server = httpStub.getfile()
            data = server.read()
            while data:
		sys.stderr.write(data + '\n')
		data = server.read()
            sys.exit(3)

	# Show results
	server = httpStub.getfile()
	data = server.read()
	while data:
		print data
		data = server.read()
	return


main()
