/*
 *  LPresent.java
 *
 */
/**
 * <p>Title: </p>
 * <p>Description: Demo Documentmethode For Signed Documents</p>
 * <p>Copyright: Copyright (c) 2002</p>
 * @author Razi Lotfi-Tabrizi
 * @version 1.0
 */

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;
import java.security.KeyStore;
//  import javax.net.*;
//  import javax.net.ssl.*;
import java.security.cert.*;
import javax.security.cert.X509Certificate;


public class LPresent extends JFrame {
    private TitledBorder titledBorder1;
    private JButton jButtonExit;
    private JButton jButtonClear;
    private JPanel jPanelAttr;
    private JLabel jLabelContent;
    private JScrollPane jScrollPane2;
    private JScrollPane jScrollPane1;
    private JButton jButtonGetAttributes;
    private JButton jButtonGetContent;
    private JPanel jPanelDC;
    private JButton jButtonGetCert;
    private JButton jButtonGetDocuSig;
    private JTabbedPane jTabbedPane2;
    private JButton jButtonGetPKey;
    private JTextArea jTextArea2;
    private JTextArea jTextArea1;
    private JButton jButtonGetMethod;
    private JButton jButtonVerifySignature;
    private JLabel jLabel1;
    private JLabel jLabel1icon;
    
    private BufferedReader br;
    private int textAreaPosition;
    private int infoAreaPosition;

    public static LPresent  tester;
    private String thisMethodLocation;
    private ImageIcon icon;
    private ImageIcon iconCaution;


    public LPresent(String id) throws Exception {
	jButtonExit = new JButton();
	jButtonClear = new JButton();
	jPanelAttr = new JPanel();
	jLabelContent = new JLabel();
	jButtonGetAttributes = new JButton();
	jButtonGetContent = new JButton();
	jPanelDC = new JPanel();
	jButtonGetCert = new JButton();
	jButtonGetDocuSig = new JButton();
	jTabbedPane2 = new JTabbedPane();
	jButtonGetPKey = new JButton();
	jTextArea2 = new JTextArea();
	jTextArea1 = new JTextArea();
	jButtonGetMethod = new JButton();
	jButtonVerifySignature = new JButton();
	jLabel1 = new JLabel();
	String initText1;
	String initText2;

	this.getContentPane().setLayout(null);
//////////////////////////////////////////////////
    	this.setTitle("Demo for signed document " + Self.getId());
//      this.setTitle("Demo for signed document ");

	this.thisMethodLocation = "jar:file:" + 
	    (Self.getContentFile()).getParent() + 
	    "/code/LPresent" + "!/";

	jButtonExit.setBounds(new Rectangle(282, 685, 100, 30));
	jButtonExit.setText("Exit");
	jButtonExit.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    jButtonExit_actionPerformed(e);
		}
	    });

	jButtonGetContent.setBounds(new Rectangle(17, 524, 162, 30));
	jButtonGetContent.setText("Reload Content");
	jButtonGetContent.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    normalCasejLabel1icon();	
		    jButtonGetContent_actionPerformed(e);
		}
	    });
	
	jButtonClear.setBounds(new Rectangle(198, 524, 162, 30));
	jButtonClear.setText("Clear");
	jButtonClear.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    normalCasejLabel1icon();	
		    jButtonClear_actionPerformed(e);
		}
	    });

	jButtonGetAttributes.setBounds(new Rectangle(13, 456, 130, 30));
	jButtonGetAttributes.setText("Attributes");
	jButtonGetAttributes.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    normalCasejTextArea2();
		    normalCasejLabel1icon();	
		    jButtonGetAttributes_actionPerformed(e);
		}
	    });

	jButtonGetMethod.setBounds(new Rectangle(165, 456, 130, 30));
	jButtonGetMethod.setToolTipText("Get The List Of Documentmethods");
	jButtonGetMethod.setText("Methods");
	jButtonGetMethod.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    normalCasejTextArea2();
		    normalCasejLabel1icon();	
		    jButtonGetMethod_actionPerformed(e);
		}
	    });

	jButtonGetCert.setBounds(new Rectangle(13, 498, 130, 30));
	jButtonGetCert.setText("Certificate");
	jButtonGetCert.setToolTipText("Get Author\'s Certificate");
	jButtonGetCert.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    normalCasejTextArea2();
		    normalCasejLabel1icon();	
		    jButtonGetCert_actionPerformed(e);
		}
	    });

	jButtonGetPKey.setBounds(new Rectangle(165, 498, 130, 30));
	jButtonGetPKey.setText("Public Key");
	jButtonGetPKey.setToolTipText("Get Author\'s Public Key");
	jButtonGetPKey.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    normalCasejTextArea2();
		    normalCasejLabel1icon();	
		    jButtonGetPKey_actionPerformed(e);
		}
	    });

	jButtonGetDocuSig.setBounds(new Rectangle(13, 540, 130, 30));
	jButtonGetDocuSig.setText("Signature");
	jButtonGetDocuSig.setToolTipText("Get the digital signature of document content created by the author.");
	jButtonGetDocuSig.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    normalCasejTextArea2();
		    normalCasejLabel1icon();	
		    jButtonGetDocuSig_actionPerformed(e);
		}
	    });


	jButtonVerifySignature.setBounds(new Rectangle(416, 525, 156, 37));
	jButtonVerifySignature.setToolTipText("Verify the signature of document content");
	jButtonVerifySignature.setText("Verify Signature");
	jButtonVerifySignature.addActionListener(new java.awt.event.ActionListener() {
		public void actionPerformed(ActionEvent e) {
		    normalCasejTextArea2();
		    jButtonVerifySignature_actionPerformed(e);
		}
	    });

	jLabelContent.setBounds(new Rectangle(6, 6, 197, 26));
	jLabelContent.setForeground(Color.black);
	jLabelContent.setText("Document Content");

	jLabel1.setBounds(new Rectangle(12, 5, 326, 64));
	jLabel1.setForeground(Color.blue);
	jLabel1.setFont(new java.awt.Font("Dialog", 3, 16));
	jLabel1.setDisplayedMnemonic('0');
	jLabel1.setHorizontalAlignment(SwingConstants.LEFT);
	jLabel1.setText("Demo for signed documents");

	// First icon for normalcase
  	URL imgURL = null;
	String iconLocation;
  	try {
            imgURL = this.getClass().getResource("/folderlock.png");
//  	    imgURL = ClassLoader.getSystemResource("folderlock.png");
  	}
  	catch (Exception e) {
  	}
	if (imgURL == null) {
	    try {
		iconLocation = thisMethodLocation + "folderlock.png";
		imgURL = new URL(iconLocation);
	    }
	    catch (Exception e) {
		System.out.println("Failed to load image!!!");
	    }
	}
	if (imgURL != null) {
	    icon = new ImageIcon(imgURL);
	}
	else {
	    icon = new ImageIcon("folderlock.png");
	}

	// Second icon for caution
  	imgURL = null;
	iconLocation = null;
  	try {
            imgURL = this.getClass().getResource("/caution.gif");
  	}
  	catch (Exception e) {
  	}
	if (imgURL == null) {
	    try {
		iconLocation = thisMethodLocation + "caution.gif";
		imgURL = new URL(iconLocation);
	    }
	    catch (Exception e) {
		System.out.println("Failed to load caution image!!!");
	    }
	}
	if (imgURL != null) {
	    iconCaution = new ImageIcon(imgURL);
	}
	else {
	    iconCaution = new ImageIcon("caution.gif");
	}
	
	jLabel1icon = new JLabel(icon);
	jLabel1icon.setBounds(new Rectangle(550, 15, 70, 64));
	jLabel1icon.setDisplayedMnemonic('0');
	jLabel1icon.setHorizontalAlignment(SwingConstants.RIGHT);

	jPanelDC.setLayout(null);
	jPanelAttr.setLayout(null);

	jTabbedPane2.setBounds(new Rectangle(11, 66, 640, 605));
	jTabbedPane2.setMinimumSize(new Dimension(12, 42));

  	jTextArea1.setEditable(false);
	jTextArea1.setFont(new java.awt.Font("Serif", 0, 15));
	jScrollPane1 = new JScrollPane(jTextArea1);
	jScrollPane1.setBounds(new Rectangle(6, 37, 599, 468));
	jPanelDC.add(jScrollPane1, null);
	jPanelDC.add(jButtonGetContent, null);
	jPanelDC.add(jButtonClear, null);
	jPanelDC.add(jLabelContent, null);

 	jTextArea2.setEditable(false);
	jTextArea2.setFont(new java.awt.Font("DialogInput", 0, 12));
	jScrollPane2 = new JScrollPane(jTextArea2);
	jScrollPane2.setBounds(new Rectangle(13, 16, 589, 428));
	jPanelAttr.add(jScrollPane2, null);
	jPanelAttr.add(jButtonGetAttributes, null);
	jPanelAttr.add(jButtonGetMethod, null);
	jPanelAttr.add(jButtonGetPKey, null);
	jPanelAttr.add(jButtonVerifySignature, null);
	jPanelAttr.add(jButtonGetCert, null);
	jPanelAttr.add(jButtonGetDocuSig, null);
	jPanelAttr.add(jButtonGetAttributes, null);
	
	jTabbedPane2.add(jPanelDC, "Content");
	jTabbedPane2.add(jPanelAttr, "Attributes");

	this.getContentPane().add(jLabel1icon, null);
	this.getContentPane().add(jLabel1, null);
	this.getContentPane().add(jButtonExit, null);
	this.getContentPane().add(jTabbedPane2, null);

	setSize(665,750);
	
	initText1 = 
	    "Please click the \"Reload Content\" bottom to see the content of this document!" ;
	jTextArea1.append(initText1); 
  	textAreaPosition = initText1.length();
	initText2 = 
	    "Click to see information about this document!";
	jTextArea2.append(initText2); 
  	infoAreaPosition = initText2.length();

	
	addWindowListener(new WindowAdapter() {
		public void windowClosing(WindowEvent e) {
		    closeDialog (e);
  		}
  	    });
    }

    public void normalCasejTextArea2() {
	jTextArea2.setForeground(Color.black);
	jTextArea2.setFont(new java.awt.Font("DialogInput", 0, 12));
	jTextArea2.setBackground(Color.white);
    }

    
    public void normalCasejLabel1icon() {
	jLabel1icon.setIcon(icon);
	jLabel1icon.setBounds(new Rectangle(550, 15, 70, 64));
	jLabel1icon.setDisplayedMnemonic('0');
	jLabel1icon.setHorizontalAlignment(SwingConstants.RIGHT);
    }

    public void cautionCasejLabel1icon() {
	jLabel1icon.setIcon(iconCaution);
	jLabel1icon.setBounds(new Rectangle(400, 5, 250, 85));
	jLabel1icon.setDisplayedMnemonic('0');
	jLabel1icon.setHorizontalAlignment(SwingConstants.RIGHT);
    }


    public void jButtonGetContent_actionPerformed(ActionEvent e) {
	String line;
	File tmpFile;
        
	jTextArea1.replaceRange("", 0, textAreaPosition);
  	textAreaPosition = 0;
	
	try {
	    tmpFile = Self.getContentFile();
	    br = new BufferedReader(new FileReader(tmpFile));
	    while ((line = br.readLine()) != null) {
		textAreaPosition = textAreaPosition + line.length() + 1;
		jTextArea1.append(line);
		jTextArea1.append("\n");
	    }
	    br.close();
	    tmpFile = null;
	}
        catch (Exception ee) {
	    System.err.println("jButtonGetContent_actionPerformed");
	    System.err.println("Error by acces:   document method file");
	    return;
	}
    }

    public void jButtonClear_actionPerformed(ActionEvent e) {
	jTextArea1.replaceRange("", 0, textAreaPosition);
  	textAreaPosition = 0;
    }

    public void jButtonGetAttributes_actionPerformed(ActionEvent e) {
	String test;
	File tmpFile;
	BufferedReader br;
	String line;
	
	jTextArea2.replaceRange("", 0, infoAreaPosition);
 	infoAreaPosition = 0;
	
	test = 
	    "Contentfile-Location:      " + 
	    Self.getContentFileName() + "\n" +
	    "Contentfile-Length:        " +
	    Self.ContentFileLength()  + "\n" +
	    "Contentfile-LastModified:  " +
	    Self.ContentFileLastModifiedToString() + "\n\n\n" +
	    "Document attributes:       " + "\n";
	jTextArea2.append(test); 
	infoAreaPosition = infoAreaPosition + test.length();

	try {
	    tmpFile = Self.getAttributesFile();
	    br = new BufferedReader(new FileReader(tmpFile));
	    while ((line = br.readLine()) != null) {
		infoAreaPosition = infoAreaPosition + line.length() + 1;
		jTextArea2.append(line);
		jTextArea2.append("\n");
	    }
	    br.close();
	    tmpFile = null;
	} 
	catch (Exception ee) {
	    System.err.println("jButtonGetAttributes_actionPerformed");
	    System.err.println("Error by acces");
	}
    }

    public void jButtonGetMethod_actionPerformed(ActionEvent e) {
	String test;
	File tmpFile;
	BufferedReader br;
	String line;

	jTextArea2.replaceRange("", 0, infoAreaPosition);
 	infoAreaPosition = 0;
	
	test = 
	    "Document methods:          " + "\n";
	jTextArea2.append(test); 
	infoAreaPosition = infoAreaPosition + test.length();

	try {
	    tmpFile = Self.getMethodsFile();
	    br = new BufferedReader(new FileReader(tmpFile));
	    while ((line = br.readLine()) != null) {
		infoAreaPosition = infoAreaPosition + line.length() + 1;
		jTextArea2.append(line);
		jTextArea2.append("\n");
	    }
	    br.close();
	    tmpFile = null;
	} 
	catch (Exception ee) {
	    System.err.println("jButtonGetMethod_actionPerformed");
	    System.err.println("Error by acces");
	}	
    }

    public void jButtonGetDocuSig_actionPerformed(ActionEvent e){
	String test;
	String line;

	jTextArea2.replaceRange("", 0, infoAreaPosition);
 	infoAreaPosition = 0;
	
	test = Self.getContentFileDigitalSignatureToString();
	infoAreaPosition = infoAreaPosition + test.length();

	try {
	    jTextArea2.append(test);
	}
	catch (Exception ee) {
	    System.err.println("jButtonGetDocuSig_actionPerformed");
	    System.err.println("Error by acces");
	}	
    }

    public void jButtonGetCert_actionPerformed(ActionEvent e) {
	String test;
	String line;
	Certificate authorCert;

	jTextArea2.replaceRange("", 0, infoAreaPosition);
 	infoAreaPosition = 0;
	
	authorCert = Self.getAuthorCertificate();
	test = authorCert.toString();
	infoAreaPosition = infoAreaPosition + test.length();

	try {
	    jTextArea2.append(test);
	}
	catch (Exception ee) {
	    System.err.println("jButtonGetCert_actionPerformed");
	    System.err.println("Error by acces");
	}	
    }

    public void jButtonGetPKey_actionPerformed(ActionEvent e) {
	String test;
	String line;
	java.security.PublicKey authorpKey;

	jTextArea2.replaceRange("", 0, infoAreaPosition);
 	infoAreaPosition = 0;
	
	authorpKey = Self.getAuthorPublicKey();
	test = 
	    "Serial-Version-UID of authors public key: " + 
	    authorpKey.serialVersionUID + "\n" +
	    "Public key format:                        " + 
	    authorpKey.getFormat() + "\n" + 
	    "Public key algorithm:                     " + 
	    authorpKey.getAlgorithm() + "\n" +
	    "Authors public key:                       " + 
	    (authorpKey).toString() + "\n\n" +
	    "-----BEGIN PUBLIC KEY-----\n" +
	    ((new sun.misc.BASE64Encoder()).encode(authorpKey.getEncoded())) + 
	     "\n-----END PUBLIC KEY-----\n";
	infoAreaPosition = infoAreaPosition + test.length();

	try {
	    jTextArea2.append(test);
	}
	catch (Exception ee) {
	    System.err.println("jButtonGetPKey_actionPerformed");
	    System.err.println("Error by acces");
	}	
    }

    public void jButtonVerifySignature_actionPerformed(ActionEvent e) {
	String test;
	String line;
	java.security.PublicKey authorpKey;

	jTextArea2.replaceRange("", 0, infoAreaPosition);
 	infoAreaPosition = 0;

	if (Self.verifyContentFileDigitalSignature()) {
	    test = 
		"\n\n\n\n\tThe digital signature is TRUE";
	    jTextArea2.setForeground(Color.black);
	    jTextArea2.setBackground(Color.green);
	    jTextArea2.setFont(new java.awt.Font("DialogInput", 0, 20));
	    normalCasejLabel1icon();
	}
	else {
	    test = 
		"\n\n\n\n\t----------WARNING----------\n\n\tThe digital signature is FALSE\n\n\t----------WARNING----------";
	    jTextArea2.setForeground(Color.black);
	    jTextArea2.setBackground(Color.red);
	    jTextArea2.setFont(new java.awt.Font("DialogInput", 0, 20));
	    cautionCasejLabel1icon();
	}
	infoAreaPosition = infoAreaPosition + test.length();
	
	try {
	    jTextArea2.append(test);
	}
	catch (Exception ee) {
	    System.err.println("jButtonVerifySignature_actionPerformed");
	    System.err.println("Error by acces");
	}	
    }

    private void closeDialog(WindowEvent e) {
	Thread.yield();
	dispose();
  	synchronized(tester) {
	    tester.notifyAll();
  	}
	setVisible (false);
    }
    
    public void jButtonExit_actionPerformed(ActionEvent e) {
  	Thread.yield();
  	dispose();
 	synchronized(tester) {
  	    tester.notifyAll();
  	}
    }

    public static void main(String[] args) throws Exception {

	if (args.length != 1) {
	    System.err.println("usage: LPresent <id>");
	    return;
	}

	tester = new LPresent(args[0]);
	tester.show();

  	synchronized(tester) {
	    try {
		tester.wait();
	    }
	    catch (InterruptedException e){}
	}

  	Thread.yield();
  	tester.dispose();
  	tester.setVisible (false);
  	tester.removeAll();

//  	return;
    }

}







