/*
 *  Present.java
 *
 */
import java.lang.*;
import java.util.*;
import java.io.*;
import java.net.*;

import java.security.KeyStore;
import javax.net.*;
import javax.net.ssl.*;
import javax.security.cert.X509Certificate;


public class Present {

    // Present takes two additional arguments, a hostname and a port number
    public static void main(String args[]) {
	System.err.println("Present starts");
	
//  	Io.init();
//  	Io.println("Hier wird die Present.class gestartet...");
//  	Io.println("{");
//  	Io.println("args.length: " + args.length);
//  	Io.println("Die Argumente der Main-Methode sind:");
//  	for (int i = 0; i < args.length ; i++) {
//  	    Io.println("Argument " + i + ":  " + args[i]);
//  	}
//  	if (args.length > 0) {
//  	    Io.println(args[args.length - 1]);
//  	}
//  	Io.println("}");
//  	Io.println("");



	if (args.length != 3) {
	    System.err.println("usage: Present <id> <host> <port>");
	    return;
	}

	int number;
	try {
	    number = new Integer(args[2]).intValue();
	}
	catch (Exception e) {
	    System.err.println("Bad port number: " + args[2]);
	    return;
	}

	// Perform server provided transport on myself and invoke e
	String newId = Base.s_transport(args[1], number, args[0]);
	Base.invokeAsync(args[1], number, newId, "LPresent", null);

	System.err.println("Present done.");
	return;
    }
}
