/*
 *  Id.java
 *
 *  $Id: Id.java,v 2.6 1999/12/19 16:14:54 razi Exp $
 *  $Revision: 2.6 $ $Date: 1999/12/19 16:14:54 $
 *
 *  Copyright (C) 1999  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Christian Moench
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *  Tel.  +49 69 79828358
 *  Fax.  +49 69 79823340
 *
 *  $Log: Id.java,v $
 *  Revision 2.6  1999/12/19 16:14:54  razi
 *  Including IndigoConfig.java
 *
 *  Revision 2.2  1999/12/15 16:37:22  cristian
 *  cleanups
 *
 *  Revision 1.2  1999/12/13 18:30:07  cristian
 *  new method scheme started
 *
 *  Revision 1.1  1999/07/29 18:51:49  cristian
 *  Initial release
 *
 *
 */
import java.net.*;
import java.lang.*;

public class Id {

    static public String getId() {
	String milliSeconds;
	String threadId;

	threadId = Integer.toString(Thread.currentThread().hashCode());
	milliSeconds = Long.toString(System.currentTimeMillis());
	return threadId + "-" + milliSeconds;
    }
}
