#!/bin/bash

## JAVA4
CURRENTDIR=`pwd`
SCRIPTDIR=`dirname $CURRENTDIR/$0`
export CLASSPATH=$SCRIPTDIR:$CLASSPATH

###################################
#KEYSTORE=$SCRIPTDIR/../../certificates/User-CA/User/Christian-client.keystore
KEYSTORE=$SCRIPTDIR/../../certificates/User-CA/User/Christian.keystore
KEYSTOREPASSWORD=Christian
TRUSTSTORE=$SCRIPTDIR/../../certificates/User-CA/User/Christian.truststore
#TRUSTSTORE=$SCRIPTDIR/../../certificates/User-CA/User/Christian.keystore
TRUSTSTOREPASSWORD=Christian
###################################



# keytool -list -v -keystore $KEYSTORE -storepass $KEYSTOREPASSWORD

# -Djavax.net.debug=all
java -classpath $CLASSPATH -Dindigo.keyStore=$KEYSTORE -Dindigo.keyStorePassword=$KEYSTOREPASSWORD -Dindigo.keyStoreType=JKS -Dindigo.keyManagerFactoryAlgorithm=SunX509 -Dindigo.trustStore=$TRUSTSTORE -Dindigo.trustStorePassword=$TRUSTSTOREPASSWORD -Dindigo.trustStoreType=JKS -Dindigo.trustManagerFactoryAlgorithm=SunX509 -Dindigo.httpsProtocols=SSL SSLClientWithClientAuth $*

