/*
 *  Run.java  $Revision: 2.7 $
 *
 *  $Id: Run.java,v 2.7 1999/12/21 14:51:56 cristian Exp $
 *  $Date: 1999/12/21 14:51:56 $
 *
 *  Copyright (C) 1999  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Christian Moench
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *  Tel.  +49 69 79828358
 *  Fax.  +49 69 79823340
 *
 *  $Log: Run.java,v $
 *  Revision 2.7  1999/12/21 14:51:56  cristian
 *  added some System.out-outputs
 *
 *  Revision 2.6  1999/12/19 16:14:47  razi
 *  Including IndigoConfig.java
 *
 *  Revision 2.2  1999/12/15 16:44:51  cristian
 *  new revision
 *
 *  Revision 1.3  1999/12/15 10:20:11  cristian
 *  *** empty log message ***
 *
 *  Revision 1.2  1999/08/09 09:32:59  cristian
 *  nothin
 *
 *
 */


public class Run {

    public static void main(String args[]) {

	Io.init();
	Io.print("Run#main({");
	System.out.print("Run#main({");
	for (int i = 0; i < args.length - 1; i++) {
	    Io.print(args[i] + ", ");
	    System.out.print(args[i] + ", ");

	}
	if (args.length > 0) {
	    Io.print(args[args.length - 1]);
	    System.out.print(args[args.length - 1]);
	}
	Io.println("}");
	System.out.println("}");

	String[] as = {"G", "o"};
	String[] result;
	if (args.length == 1) {
	    result = Base.invoke("localhost", 7333, args[0], "Go", as);
	} else {
	    result = Base.invoke("localhost", 7333, args[0], args[1], as);
	}
	if (result == null) {
	    Io.println("Error: " + Base.getLastError());
	    return;
	}
	for (int i = 0; i < result.length; i++) {
	    Io.println(result[i]);
	    System.out.println(result[i]);
	}

	String newId = Base.s_transport("localhost", 7333, args[0]);
	if (newId == null) {
	    Io.println("Error: " + Base.getLastError());
	    return;
	}
	result = Base.invoke("localhost", 7333, newId, "Go", as);
	for (int i = 0; i < result.length; i++) {
	    Io.println(result[i]);
	    System.out.println(result[i]);
	}
	Io.exit();
    }
}
