/*
 *  Copyright (C) 1999  Razi Lotfi-Tabrizi 
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Razi Lotfi-Tabrizi
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *
 *
 *
 */
import java.lang.*;
import java.io.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.text.*;


public class Info {

    public static void main(String args[]) {
	Self SelfObj = new Self();
	
	Io.init();
	Io.println("Hier wird die Info.class gestartet...");
	Io.println("{");
	Io.println("args.length: " + args.length);
	Io.println("Die Argumente der Main-Methode sind:");
	for (int i = 0; i < args.length ; i++) {
	    Io.println("Argument " + i + ":  " + args[i]);
	}
	if (args.length > 0) {
	    Io.println(args[args.length - 1]);
	}
	Io.println("}");
	Io.println("");
	

	SelfObj.PrintContentFileInfo();
	Io.println("");
	Io.println("");
	SelfObj.PrintMethodsFile();
	Io.println("");
	Io.println("");
	SelfObj.PrintAttributesFile(); 

	Io.println("Hier wird die Info.class beendet...");
	try {
	    Thread.currentThread().sleep(30000);
	}
	catch (InterruptedException e) {}
	Io.exit();
    }
}

