/*
 *  Protocol.java  $Revision: 1.1.1.1 $
 *
 *  $Id: Protocol.java,v 1.1.1.1 1999/12/20 13:11:59 razi Exp $
 *  $Date: 1999/12/20 13:11:59 $
 *
 *  Copyright (C) 1999  Christian Moench
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  Christian Moench
 *  Dept. of Computer Science
 *  Johann Wolfgang Goethe-University
 *  60325 Frankfurt, Germany
 *  Tel.  +49 69 79828358
 *  Fax.  +49 69 79823340
 *
 *  $Log: Protocol.java,v $
 *  Revision 1.1.1.1  1999/12/20 13:11:59  razi
 *  Lokale Indigo Server auf papageno
 *
 *
 */
import java.io.*;
import java.awt.*;


public class Protocol implements Serializable {

    public Protocol() {
	return;
    }

    public class Pixel extends Protocol {
	public int   xPosition, yPosition;
	public Color pixelColor;

	public Pixel(int xPos, int yPos, Color aColor) {
	    xPosition  = xPos;
	    yPosition  = yPos;
	    pixelColor = aColor;
	    return;
	}
    }

    public class Info extends Protocol {
	public int theWidth;
	public int theHeight;

	public Info(int width, int height) {
	    theWidth  = width;
	    theHeight = height;
	    return;
	}
    }
}
